using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using InstrumentDrivers;

namespace RSSMA_AM_External_Example
{
    public partial class dialog : Form
    {
        public dialog()
        {
            InitializeComponent();
        }

        private void dialog_Load(object sender, EventArgs e)
        {
            AMExtCoupling.SelectedIndex = 0;
        }
        
        private void ExitBTN_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void ApplyBTN_Click(object sender, EventArgs e)
        {
            rssma instrument;

            try
            {
                UseWaitCursor = true;
                System.Windows.Forms.Cursor.Current = Cursors.WaitCursor;
                instrument = new rssma(ResourceDescriptor.Text, IDQuery.Checked, ResetDevice.Checked);

                instrument.configAM (AMState.Checked, rssmaConstants.AmSourceExt, Decimal.ToDouble (AMDepth.Value), AMExtCoupling.SelectedIndex, rssmaConstants.AmInternalSourceLf1, 30.0, 1000.0, rssmaConstants.LfoutputShapeSine, 1000.0);

                instrument.confRFFreq(Decimal.ToDouble(RFFrequency.Value), 0.0, false, 0.0);

                instrument.confRFLevel(Decimal.ToDouble(RFLevel.Value), 0.0, 30.0, false, 0.0, rssmaConstants.OutputAmodeAuto, rssmaConstants.PowerLevelRclExclude);

                instrument.SetOutputState(RFState.Checked);
            }
            catch (Exception ex)
            {
                String message;

                message = "Instrument Status Error: ";
                message += ex.Message;
                MessageBox.Show(message);
            }
            System.Windows.Forms.Cursor.Current = Cursors.Arrow;
            UseWaitCursor = false;
        }

        
    }
}