using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using InstrumentDrivers;

namespace RSSMA_List_Mode_Example
{
    public partial class dialog : Form
    {
        public dialog()
        {
            InitializeComponent();
        }

        private void dialog_Load(object sender, EventArgs e)
        {
            Mode.SelectedIndex = 0;
            TriggerSlope.SelectedIndex = 0;
        }
        
        private void ExitBTN_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void ApplyBTN_Click(object sender, EventArgs e)
        {
            rssma instrument;

            try
            {
                UseWaitCursor = true;
                System.Windows.Forms.Cursor.Current = Cursors.WaitCursor;
                instrument = new rssma(ResourceDescriptor.Text, IDQuery.Checked, ResetDevice.Checked);

                string strDirectory = Directory.Text;
                string strList = List.SelectedText;

                instrument.SetLISTSelectList(strDirectory + "\\" + strList);
                instrument.SetLISTMode(Mode.SelectedIndex);

                instrument.SetLISTDwellTime(Decimal.ToDouble(Dwell.Value));
                
                switch ( Mode.SelectedIndex )
                {
                    case 3: // extern single
                    case 4: // extern step
                    case 5: // extern hop
                        instrument.SetInstrumentTriggerInputSlope(TriggerSlope.SelectedIndex);
                        break;
                }


                instrument.SetOutputState(RFState.Checked);
            }
            catch (Exception ex)
            {
                String message;

                message = "Instrument Status Error: ";
                message += ex.Message;
                MessageBox.Show(message);
            }
            System.Windows.Forms.Cursor.Current = Cursors.Arrow;
            UseWaitCursor = false;
        }

        private void OnModeChange(object sender, EventArgs e)
        {
            int nMode = Mode.SelectedIndex;
            bool bEnable = false;

            switch (nMode)
            {
                case 3: // Extern single
                case 4: // Extern step
                case 5: // Extern hop
                    bEnable = true;
                    break;
            }

            TriggerSlope.Enabled = bEnable;
            TriggerSlopeLabel.Enabled = bEnable;
        }

        private void OnFillList(object sender, EventArgs e)
        {

            rssma instrument;

            try
            {
                UseWaitCursor = true;
                System.Windows.Forms.Cursor.Current = Cursors.WaitCursor;
                instrument = new rssma(ResourceDescriptor.Text, IDQuery.Checked, ResetDevice.Checked);

                string strDirectory = Directory.Text;
                if ( strDirectory != "" )
                {
                    instrument.MMEMoryChangeDirectory(strDirectory);
                }

                StringBuilder catalogList = new StringBuilder();
                instrument.LISTCatalog("", 256, catalogList);

                string strText = catalogList.ToString();
                string[] strParts = strText.Split(new char[] {','});

                List.Items.Clear();
                foreach (string strPart in strParts)
                {
                    List.Items.Add(strPart);
                }
            }
            catch (Exception ex)
            {
                String message;

                message = "Instrument Status Error: ";
                message += ex.Message;
                MessageBox.Show(message);
            }
            System.Windows.Forms.Cursor.Current = Cursors.Arrow;
            UseWaitCursor = false;
        }

        
    }
}